#!/bin/sh
VENDORMODEL=`cat prepare-u-boot.sh | grep -m1 -E '^VENDORMODEL=' | cut -d '=' -f 2-`
TAG=`cat prepare-u-boot.sh | grep -m1 -E '^TAG=' | cut -d '=' -f 2-`
RELNAME=`cat prepare-u-boot.sh | grep -m1 -E '^RELNAME=' | cut -d '=' -f 2-`

MK_ARCH="$(uname -m)"
echo ${MK_ARCH}
if [ "aarch64" != ${MK_ARCH} ]; then
	echo "cross complie"
        export ARCH=arm64
        export CROSS_COMPILE=aarch64-linux-gnu-
fi

cd u-boot-${VENDORMODEL}

if [ "${VENDORMODEL}" != "odroid-n1" ]; then
  sed -i s/odroid-n1/${VENDORMODEL}/g Makefile
fi

#./build-dpkg.sh
make prepare

cd denx

sed -i 's|tools/rk_tools/bin/loaderimage|tools/loaderimage|g' build.sh
sed -i 's|tools/rk_tools/bin/trust_merger|tools/trust_merger ${BIN_PATH_FIXUP}|g' build.sh

defsoc=rk3399
defcfg=odroidn1_defconfig
if [ -e configs/${VENDORMODEL}-rk3399_defconfig ]; then
  defcfg=${VENDORMODEL}-${defsoc}_defconfig

elif [ -e configs/${VENDORMODEL/-/_}-rk3399_defconfig ]; then
  defcfg=${VENDORMODEL/-/_}-${defsoc}_defconfig

elif [ -e configs/${VENDORMODEL}-rk3328_defconfig ]; then
  defsoc=rk3328
  defcfg=${VENDORMODEL}-${defsoc}_defconfig

elif [ -e configs/${VENDORMODEL/-/_}-rk3328_defconfig ]; then
  defsoc=rk3328
  defcfg=${VENDORMODEL/-/_}-${defsoc}_defconfig

fi

rkmini=RK3399MINIALL

if [ "${defsoc}" = "rk3328" ]; then
  rkmini=RK3328MINIALL
  sed -i 's|^cp .*/rk33/rk3399_loader_v.*\.bin|tools/boot_merger ${BIN_PATH_FIXUP} tools/rk_tools/RKBOOT/RK3328MINIALL.ini ; cp rk3328_loader_v*.bin|g' build.sh

else
  sed -i 's|^cp .*/rk33/rk3399_loader_v.*\.bin|tools/boot_merger ${BIN_PATH_FIXUP} tools/rk_tools/RKBOOT/RK3399MINIALL.ini ; cp rk3399_loader_v*.bin|g' build.sh
fi

sed -i s/odroidn1_defconfig/${defcfg}/g build.sh


cd ..

rm -rf denx/tools/rk_tools/bin/
rm -rf denx/tools/rk_tools/RKBOOT/
cp -apP rkbin/bin denx/tools/rk_tools/
cp -apP rkbin/RKBOOT denx/tools/rk_tools/

getrkbin() {
	l=$1
	[ "x$3" != "x" ] && l=$3
	#cd u-boot-${VENDORMODEL}
	for f in rkbin/bin/rk33/${l}*.$2 ; do
		if [ -e $f ]; then
			b=`basename $f`
			echo $1.*\.$2 $b
			sed -i s/$1.*\.$2/$b/g denx/build.sh
			sed -i s/$1.*\.$2/$b/g denx/tools/rk_tools/trust.ini
			sed -i s/$1.*\.$2/$b/g denx/tools/rk_tools/RKBOOT/${rkmini}.ini
		fi
	done
	#cd ..
}

if [ "${defsoc}" = "rk3328" ]; then
  getrkbin rk3399_ddr_800MHz_v bin rk3328_ddr_786MHz_v
  getrkbin rk3399_miniloader_v bin rk3328_miniloader_v
  getrkbin rk3399_loader_v bin     rk3328_loader_ddr333_v

  getrkbin rk3399_bl31_v elf rk3328_bl31_v

  getrkbin rk3399_ddr_800MHz_v bin rk3328_ddr_333MHz_v
  getrkbin rk3399_miniloader_v bin rk322xh_miniloader_v
  getrkbin rk3399_loader_v bin     rk3328_loader_ddr333_v

  getrkbin rk3399_bl31_v elf rk322xh_bl31_v

  sed -i s/'n rk3399'/'n rk3328'/g denx/build.sh

else
  #getrkbin rk3399_ddr_800MHz_v bin
  getrkbin rk3399_ddr_800MHz_v bin rk3399_ddr_933MHz_v
  getrkbin rk3399_miniloader_v bin
  getrkbin rk3399_loader_v bin

  getrkbin rk3399_bl31_v elf
fi

sed -i "s|=bin/|=../rkbin/bin/|g" denx/tools/rk_tools/RKBOOT/${rkmini}.ini

make clean

chmod ugo+rx denx/build.sh

cd ..

#exit

echo "Packing u-boot-${TAG}-${RELNAME}-${VENDORMODEL}-source..."

tar czf u-boot-${TAG}-${RELNAME}-${VENDORMODEL}-source.tar.gz u-boot-${VENDORMODEL}

#exit

echo "Building u-boot-${TAG}-${RELNAME}-${VENDORMODEL} using ${defcfg}..."

cd u-boot-${VENDORMODEL}

dpkg-buildpackage -aarm64 -d -us -uc

cd ..

uver=`ls ${VENDORMODEL}-u-boot-image_*_*.deb | cut -d _ -f 2`

if [ "${VENDORMODEL}" != "odroid-n1" ]; then
  sed -i s/odroid-n1/${VENDORMODEL}/g install-u-boot.sh
fi

zip u-boot-${uver}-${RELNAME}-${VENDORMODEL}.zip ${VENDORMODEL}-u-boot-image_*_*.deb install-*.sh

if [ "${VENDORMODEL}" != "odroid-n1" ]; then
  sed -i s/${VENDORMODEL}/odroid-n1/g install-edid.sh install-u-boot.sh
fi

echo OK
