#!/bin/sh
CHIPTOOLS=rkbin
VENDORMODEL=odroid-n1
#VENDORMODEL=rock-pi-4a
#VENDORMODEL=rock-pi-4b
#VENDORMODEL=rock960-ab
#VENDORMODEL=rock960-c
#VENDORMODEL=rock64
#VENDORMODEL=rockpro64
#VENDORMODEL=pinebook-pro
#VENDORMODEL=evb
XYPRONTAG=2018.03
TAG=2017.09
RELNAME=ayufan-20190708

TAGYEARS=`expr ${TAG:0:4} \* 416`
TAGMONTH=`expr ${TAG:5:2} \* 32`
TAGSTAMP=`expr ${TAGYEARS} + ${TAGMONTH}`

REVISION=`echo ${RELNAME} | cut -d '-' -f 2`

REVYEARS=`expr ${REVISION:0:4} \* 416`
REVMONTH=`expr ${REVISION:4:2} \* 32`
REVMDAYS=${REVISION:6:2}
REVSTAMP=`expr ${REVYEARS} + ${REVMONTH} + ${REVMDAYS}`

REVISION=`expr ${REVSTAMP} - ${TAGSTAMP}`

mkdir -p u-boot-source
cd u-boot-source

test -d u-boot-build || git clone -b v${XYPRONTAG} https://github.com/xypron/u-boot-odroid-c2 u-boot-build

#test -d denx || git clone -v -b next-dev https://github.com/rockchip-linux/u-boot denx
test -d denx || git clone -v -b rockchip-master https://github.com/ayufan-rock64/linux-u-boot denx
test -d ${CHIPTOOLS} || git clone -v -b stable-4.4-rk3399-linux https://github.com/rockchip-linux/${CHIPTOOLS} ${CHIPTOOLS}
 
cd ..

if [ ! -e u-boot-${TAG}-${RELNAME}-git-source.tar.gz ]; then
  echo "Packing u-boot-${TAG}-${RELNAME}-git-source..."

  tar czf u-boot-${TAG}-${RELNAME}-git-source.tar.gz u-boot-source
fi

echo "Preparing u-boot-${VENDORMODEL}..."

mkdir u-boot-${VENDORMODEL}
cp -apP u-boot-source/u-boot-build/. u-boot-${VENDORMODEL}/
cp -apP u-boot-source/denx u-boot-${VENDORMODEL}/
cp -apP u-boot-source/${CHIPTOOLS} u-boot-${VENDORMODEL}/

cd u-boot-${VENDORMODEL}

patch -p1 < ../u-boot-odroidn1-makefile.patch

patch -p1 < ../u-boot-odroidn1-makefile-no-hardkernel.patch
patch -p1 < ../u-boot-odroidn1-makefile-no-u-boot-git.patch

#sed -i s/'arm64'/'armhf'/g build-dpkg.sh 
#sed -i s/'arm64'/'armhf'/g debian/control 
#sed -i s/' ARCH=arm64'/' ARCH=arm'/g Makefile 
#sed -i s/'aarch64-linux-gnu-'/'arm-linux-gnueabihf-'/g Makefile
#sed -i s/'aarch64'/'armv7l'/g Makefile 

sed -i s/2018.01\.001/${TAG}.000/g debian/changelog
sed -i s/2018.01/${TAG}/g debian/changelog

sed -i s/2017.11\.001/2017.07.000/g debian/changelog
sed -i s/2017.11-rc2/2017.07/g debian/changelog
sed -i s/2017.11/2017.07/g debian/changelog

sed -i s/${XYPRONTAG}\.001/${TAG}.${REVISION}/g debian/changelog
sed -i s/${XYPRONTAG}/${TAG}/g debian/changelog

sed -i s/'Heinrich Schuchardt'/'BSP'/g debian/changelog
sed -i s/'xypron.glpk@gmx.de'/'developer@build.local'/g debian/changelog

BUILDDATE=`date -R`
sed -i "s/Sat, 17 Mar 2018 12:50:57 +0100/${BUILDDATE}/g" debian/changelog

sed -i s/'^REVISION=.*'/'REVISION='${REVISION}/g Makefile

sed -i s/'odroid-c2'/${VENDORMODEL}/g debian/changelog 
sed -i s/'odroid-c2'/${VENDORMODEL}/g debian/control 

if [ "${VENDORMODEL}" = "odroid-n1" ]; then
  sed -i s/'Odroid C2'/'Odroid N1'/g debian/control
elif [ "${VENDORMODEL}" = "rock64" ]; then
  sed -i s/'Odroid C2'/'Rock64'/g debian/control
elif [ "${VENDORMODEL}" = "rockpro64" ]; then
  sed -i s/'Odroid C2'/'RockPro64'/g debian/control
elif [ "${VENDORMODEL}" = "pinebook-pro" ]; then
  sed -i s/'Odroid C2'/'Pinebook Pro'/g debian/control
elif [ "${VENDORMODEL:0:8}" = "rock-pi-" ]; then
  sed -i s/'Odroid C2'/'Rock Pi '${VENDORMODEL:8}/g debian/control
elif [ "${VENDORMODEL:0:8}" = "rock960-" ]; then
  sed -i s/'Odroid C2'/'Rock960 '${VENDORMODEL:8}/g debian/control
fi

sed -i s/'odroid-c2'/${VENDORMODEL}/g debian/source/options 
sed -i s/meson-tools/${CHIPTOOLS}/g debian/source/options
#sed -i s/hardkernel/sunxi/g debian/source/options

sed -i s/'odroid-c2'/${VENDORMODEL}/g Makefile 
sed -i "s|make fip_create|#make fip_create|g" Makefile
sed -i "s|make sign|#make sign|g" Makefile
sed -i "s|dd if=u-boot.bin of=|#dd if=u-boot.bin of=|g" Makefile
#sed -i "s|hardkernel/sd_fuse/bl1.bin.hardkernel|denx/u-boot-sunxi-with-spl.bin|g" Makefile
sed -i "s|hardkernel/sd_fuse/sd_fusing.sh|patch/sd_fusing.sh|g" Makefile
#sed -i "s|https://github.com/hardkernel/u-boot.git|https://github.com/linux-sunxi/u-boot-sunxi|g" Makefile
sed -i "s|https://github.com/afaerber/meson-tools.git|https://github.com/radxa/${CHIPTOOLS}|g" Makefile
sed -i s/meson-tools/${CHIPTOOLS}/g Makefile
sed -i "/cd ${CHIPTOOLS} && make clean/d" Makefile
#sed -i s/hardkernel/sunxi/g Makefile

#echo 'tar-ignore = "sunxi"' >> debian/source/options

cp -p ../sd_fusing.sh ./patch/
cp -p ../config-${TAG} ./config/

rm -f patch/*.patch
rm -f patch/patch-${TAG}
echo '#!/bin/sh' > patch/patch-${TAG}
chmod ugo+rx patch/patch-${TAG}

test -d denx || git clone -v \
        -b rockchip-master https://github.com/ayufan-rock64/linux-u-boot denx
cd denx
git fetch
git checkout 2017.09-rockchip-ayufan-1065-g95f6152134
test -d patches || cp -apP ../../patches ./

mv patches/series patches/series-platform
cp -p patches/series-next-dev-20171220-to-20190125 patches/series
cat patches/series-next-dev-20190125-to-20190606 >> patches/series
cat patches/series-next-dev-20190606-to-20190708 >> patches/series
cat patches/series-platform >> patches/series

quilt push -a

pcount=`cat patches/series | grep -v -E '^#' | grep patch | wc -l`

echo "Applied ${pcount} patches."

cd ..

cd ..

#echo "Packing u-boot-${TAG}-${RELNAME}-${VENDORMODEL}-source..."

#tar czf u-boot-${TAG}-${RELNAME}-${VENDORMODEL}-source.tar.gz u-boot-${VENDORMODEL}

echo OK
